/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.attr.SRefreshRoleData
 *  fire.pb.battle.Module
 *  fire.pb.buff.BuffAgent
 *  fire.pb.buff.BuffPetImpl
 *  fire.pb.buff.BuffRoleImpl
 *  fire.pb.buff.IBuff
 *  fire.pb.buff.Module
 *  fire.pb.buff.continual.ConstantlyBuff
 *  fire.pb.buff.single.Cure
 *  fire.pb.buff.single.FixedInjure
 *  fire.pb.effect.Role
 *  fire.pb.effect.RoleImpl
 *  fire.pb.pet.PetColumn
 *  fire.pb.skill.BuffUnit
 *  fire.pb.skill.Module
 *  fire.pb.skill.SkillRole
 *  fire.pb.skill.SubSkillConfig
 *  fire.pb.team.Team
 *  fire.pb.team.TeamManager
 *  fire.pb.util.ParseObjIDOutBattle
 *  fire.script.AbstractJSEngine
 *  fire.script.JavaScript
 *  fire.script.SceneJSEngine
 *  mkdb.Lockeys
 *  mkdb.Procedure
 *  mkdb.TTable
 *  mkio.Protocol
 *  xbean.PetInfo
 *  xtable.Locks
 *  xtable.Properties
 *  xtable.Roleid2teamid
 */
package fire.pb.skill.scene;

import fire.pb.attr.SRefreshRoleData;
import fire.pb.buff.BuffAgent;
import fire.pb.buff.BuffPetImpl;
import fire.pb.buff.BuffRoleImpl;
import fire.pb.buff.IBuff;
import fire.pb.buff.continual.ConstantlyBuff;
import fire.pb.buff.single.Cure;
import fire.pb.buff.single.FixedInjure;
import fire.pb.effect.Role;
import fire.pb.effect.RoleImpl;
import fire.pb.pet.PetColumn;
import fire.pb.skill.BuffUnit;
import fire.pb.skill.Module;
import fire.pb.skill.SkillRole;
import fire.pb.skill.SubSkillConfig;
import fire.pb.skill.scene.SceneSkillConfig;
import fire.pb.team.Team;
import fire.pb.team.TeamManager;
import fire.pb.util.ParseObjIDOutBattle;
import fire.script.AbstractJSEngine;
import fire.script.JavaScript;
import fire.script.SceneJSEngine;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import mkdb.Lockeys;
import mkdb.Procedure;
import mkdb.TTable;
import mkio.Protocol;
import xbean.PetInfo;
import xtable.Locks;
import xtable.Properties;
import xtable.Roleid2teamid;

public class PSceneSkill
extends Procedure {
    public static final int GOAL_SELF_ROLE = 1;
    public static final int GOAL_SELF_PET = 2;
    public static final int GOAL_TEAM_ROLE = 3;
    private final int skillId;
    private final long opRoleId;
    private final long goalId;
    private final int goalType;
    private final SceneSkillConfig skillconfig;

    public PSceneSkill(long opRoleId, int skillId, long goalId, int goalType) {
        this.opRoleId = opRoleId;
        this.skillId = skillId;
        this.goalId = goalId;
        this.goalType = goalType;
        this.skillconfig = Module.getInstance().getSceneSkillConfig(skillId);
        if (this.skillconfig == null) {
            Module.logger.error((Object)("ERROR: Scene Skill is not exist. skillId = " + skillId));
            throw new IllegalArgumentException("ERROR: Scene Skill is not exist. skillId = " + skillId);
        }
    }

    protected boolean process() {
        Object petkey;
        boolean selfonly = true;
        ParseObjIDOutBattle objs = new ParseObjIDOutBattle(this.skillconfig.getTargettype());
        Team team = null;
        if (!objs.teammate) {
            this.lock(Lockeys.get((TTable)Locks.ROLELOCK, (Object[])new Object[]{this.opRoleId}));
        } else {
            Long teamId = Roleid2teamid.select((Long)this.opRoleId);
            if (teamId == null) {
                this.lock(Lockeys.get((TTable)Locks.ROLELOCK, (Object[])new Object[]{this.opRoleId}));
            } else {
                team = TeamManager.selectTeamByTeamID((long)teamId);
                int opteamstate = team.getTeamMemberState(this.opRoleId);
                if (opteamstate == 2) {
                    this.lock(Lockeys.get((TTable)Locks.ROLELOCK, (Object[])new Object[]{this.opRoleId}));
                } else {
                    List normalMemberIds = team.getNormalMemberIds();
                    if (normalMemberIds.size() == 1) {
                        this.lock(Lockeys.get((TTable)Locks.ROLELOCK, (Object[])new Object[]{this.opRoleId}));
                    } else {
                        this.lock(Lockeys.get((TTable)Locks.TEAMLOCK, (Object[])new Object[]{teamId}));
                        this.lock(Lockeys.get((TTable)Locks.ROLELOCK, (Collection)normalMemberIds));
                        selfonly = false;
                    }
                }
            }
        }
        BuffRoleImpl buffagent = new BuffRoleImpl(this.opRoleId);
        if (!buffagent.canAddBuff(516011)) {
            return true;
        }
        SkillRole skillrole = new SkillRole(this.opRoleId);
        int skilllevel = skillrole.getLevel(this.skillId);
        if (skilllevel == 0) {
            skilllevel = 1;
        }
        SceneJSEngine engine = new SceneJSEngine();
        engine.setSkillLevel(skilllevel);
        switch (this.goalType) {
            case 2: {
                PetColumn pets = new PetColumn(this.opRoleId, 1, false);
                PetInfo petinfo = pets.getPetInfo((int)this.goalId);
                if (petinfo != null) break;
                return true;
            }
            case 3: {
                if (team == null) {
                    return true;
                }
                if (team.getNormalMemberIds().contains(this.goalId)) break;
                return true;
            }
        }
        RoleImpl erole = new RoleImpl(this.opRoleId, false);
        engine.setOpERole((Role)erole);
        int hpconsume = this.getHPconsume((AbstractJSEngine)engine);
        if (erole.getHp() < -hpconsume) {
            return true;
        }
        int mpconsume = this.getMPconsume((AbstractJSEngine)engine);
        if (erole.getMp() < -mpconsume) {
            return true;
        }
        int spconsume = this.getSPconsume((AbstractJSEngine)engine);
        if (erole.getSp() < -spconsume) {
            return true;
        }
        SubSkillConfig mainsubskill = this.skillconfig.getSubSkills()[0];
        int targetcount = mainsubskill.getTargetCountJs().eval((AbstractJSEngine)engine, null, null).intValue();
        engine.setSkillTargetNum(targetcount);
        ArrayList<Object> buffAgents = new ArrayList<Object>();
        if (this.goalType == 1) {
            buffAgents.add(new BuffRoleImpl(this.opRoleId));
        } else if (this.goalType == 2) {
            buffAgents.add(new BuffPetImpl(this.opRoleId, (int)this.goalId));
        } else if (this.goalType == 3) {
            buffAgents.add(new BuffRoleImpl(this.goalId));
        }
        if (objs.role && this.goalType != 1) {
            buffAgents.add(new BuffRoleImpl(this.opRoleId));
        }
        if (objs.petself && this.goalType != 2 && (Integer)(petkey = Properties.selectFightpetkey((Long)this.opRoleId)) != -1) {
            buffAgents.add(new BuffPetImpl(this.opRoleId, ((Integer)petkey).intValue()));
        }
        if (!selfonly && team != null) {
            petkey = team.getNormalMemberIds().iterator();
            while (petkey.hasNext()) {
                long teamMemberId = (Long)petkey.next();
                if (teamMemberId == this.goalId) continue;
                buffAgents.add(new BuffRoleImpl(teamMemberId));
            }
        }
        for (SubSkillConfig subskill : this.skillconfig.getSubSkills()) {
            float fTargetRate = subskill.getTargetRate().eval((AbstractJSEngine)engine, null, null).floatValue();
            if ((double)fTargetRate <= Math.random()) continue;
            block6: for (BuffUnit buffarg : subskill.getBuffUnits()) {
                if (buffarg == null) break;
                IBuff buff = fire.pb.buff.Module.getInstance().createBuff(buffarg.buffIndex);
                int count = 0;
                for (BuffAgent buffAgent : buffAgents) {
                    engine.setAimERole(buffAgent.getERole());
                    Map<Integer, Float> effects = this.calcEffects(engine, buffarg.effectJavascriptMap);
                    if (buff instanceof ConstantlyBuff) {
                        ConstantlyBuff cbuff = (ConstantlyBuff)buff.copy();
                        cbuff.setEffects(effects);
                        buffAgent.addCBuffWithSP(cbuff);
                    } else if (buff instanceof Cure) {
                        ((Cure)buff.copy()).useOutBattleWithSP(buffAgent.getERole(), effects);
                    } else if (buff instanceof FixedInjure) {
                        if (effects.get(81) != null) {
                            hpconsume = (int)((float)hpconsume + effects.get(81).floatValue());
                        }
                        if (effects.get(82) != null) {
                            hpconsume = (int)((float)hpconsume + effects.get(82).floatValue() * (float)erole.getHp());
                        }
                        if (effects.get(101) != null) {
                            mpconsume = (int)((float)mpconsume + effects.get(101).floatValue());
                        }
                        if (effects.get(102) != null) {
                            mpconsume = (int)((float)mpconsume + effects.get(102).floatValue() * (float)erole.getMp());
                        }
                        if (effects.get(121) != null) {
                            hpconsume = (int)((float)hpconsume + effects.get(121).floatValue());
                        }
                        if (effects.get(122) != null) {
                            hpconsume = (int)((float)hpconsume + effects.get(122).floatValue() * (float)erole.getSp());
                        }
                    } else {
                        Module.logger.error((Object)("PSceneSkill ERROR: 战斗外使用技能，不支持的buff，Id=" + buff.getId()));
                    }
                    if (++count < targetcount) continue;
                    continue block6;
                }
            }
        }
        SRefreshRoleData roledata = new SRefreshRoleData();
        if (hpconsume != 0) {
            erole.addHp(hpconsume);
            roledata.datas.put(80, Float.valueOf(erole.getHp()));
        }
        if (mpconsume != 0) {
            erole.addMp(mpconsume);
            roledata.datas.put(100, Float.valueOf(erole.getMp()));
        }
        if (spconsume != 0) {
            erole.addSp(spconsume, 0);
            roledata.datas.put(120, Float.valueOf(erole.getSp()));
        }
        PSceneSkill.psendWhileCommit((long)this.opRoleId, (Protocol)roledata);
        fire.pb.battle.Module.getInstance().checkBattleBuff(this.opRoleId);
        return true;
    }

    private Map<Integer, Float> calcEffects(SceneJSEngine engine, Map<Integer, JavaScript> scripts) {
        HashMap<Integer, Float> effects = new HashMap<Integer, Float>();
        for (Map.Entry<Integer, JavaScript> script : scripts.entrySet()) {
            effects.put(script.getKey(), Float.valueOf(script.getValue().eval((AbstractJSEngine)engine, null, null).floatValue()));
        }
        return effects;
    }

    private int getHPconsume(AbstractJSEngine engine) {
        Double result = -this.skillconfig.getHpConsumeJavaScript().eval(engine, null, null).doubleValue();
        return result.intValue();
    }

    private int getMPconsume(AbstractJSEngine engine) {
        Double result = -this.skillconfig.getMpConsumeJavaScript().eval(engine, null, null).doubleValue();
        return result.intValue();
    }

    private int getSPconsume(AbstractJSEngine engine) {
        Double result = -this.skillconfig.getSpConsumeJavaScript().eval(engine, null, null).doubleValue();
        return result.intValue();
    }
}

